Stethoscope {
	
	var <server, <buffer, <window, <synth, <index;
	var b, n, c, sl, spec, rate = \audio;
	
	*initClass {
		SynthDef("stethoscope", { arg in, switch, bufnum;
			var z;
			z = Select.ar(switch, [InFeedback.ar(in, 2), K2A.ar(In.kr(in, 2))]); 
			ScopeOut.ar(z, bufnum);
		}).writeDefFile;
	}

	*new { arg server, numFrames=2048;
		if(server.inProcess.not, { "scope works only with internal server".error; ^nil });		^super.newCopyArgs(server).makeWindow.allocBuffer(numFrames).run;
	}
	
	makeWindow { arg w;
		var bnds, style=0, size, zx, zy;
		size = 200;
		if(w.isNil,{
			//bnds = server.window.bounds;
			window = w = SCWindow("stethoscope", 
						Rect(10 + 20  + 256, 0 + 10, size + 10 , size + 40));
						//bnds.moveBy(bnds.width, -20));
			w.view.decorator = FlowLayout(w.view.bounds);
			w.front;
			w.onClose = { this.free };
			w.view.keyDownAction = 
			{ arg view, char; 
				if(char === $h) { this.setIndexToFirstHardwareBus; this.rate = \audio }; 
				if(char === $ ) { this.run };
				if(char === $s) { n.style = style = (style + 1) % 3 };
				if(char === $j) { this.index = index - 1 };
				if(char === $k) { this.switchRate };
				if(char === $l) { this.index = index + 1 };
				if(char === $-) {  zx = zx + 0.25; n.xZoom = 2 ** zx };
				if(char === $+) {  zx = zx - 0.25; n.xZoom = 2 ** zx };				if(char === $*) {  zy = zy + 0.25; n.yZoom = 2 ** zy };
				if(char === $_) {  zy = zy - 0.25; n.yZoom = 2 ** zy };
			};
		});
		
		n = SCScope(w, Rect(0,0, size, size));
		n.background = Color.black;
		n.resize = 5;
		zx = n.xZoom.log2;
		zy = n.yZoom.log2;
		
		spec = ControlSpec.specs.at(\audiobus);
		
		sl = SCSlider(w, Rect(10, 10, w.view.bounds.width - 70, 20));
		sl.action = { arg x;
				var i; 
				i = spec.map(x.value);
				this.index = i;
			};
		sl.resize = 8;
		c = SCNumberBox(w, Rect(10,10, 25,20)).value_(0);
		c.action = { this.index = c.value;  };
		c.resize = 9;
		b = SCButton(w,Rect(10,10,25,20));
		b.states = [
			["ar",Color.black,Color.clear],
			["kr",Color.black,Color.clear]
		];
		b.resize = 9;
		b.action = {this.switchRate};
		b.valueAction = 0;
		this.index = 0;
	}
	
	allocBuffer { arg numFrames=2048;
		buffer = Buffer.alloc(server, numFrames, 2);
		n.bufnum = buffer.bufnum;
	}
	
	run {
		if(synth.isPlaying.not) {
			synth = Synth.basicNew("stethoscope", server);
			NodeWatcher.register(synth);
			server.sendMsg(9, synth.defName, synth.nodeID, 0,0, 
				\bufnum, buffer.bufnum, \in, index);
		} {
			server.sendMsg("/g_head", 0, synth.nodeID.debug) // move to head of root node.
		}
	}
	
	free {
		buffer.free;
		synth.free;
	}
	
	
	index_ { arg val=0;
		index = spec.constrain(val);
		if(synth.notNil) { synth.set(\in, index) };
		c.value = index;
		sl.value = spec.unmap(index);
		this.updateColors;
		
	}
	
	rate_ { arg argRate=\audio;
		
		if(argRate === \audio)
		{ 
				b.value = 0;
				synth.set(\switch, 0);
				rate = \audio;
				this.updateColors;
		}
		{
				b.value = 1;
				synth.set(\switch, 1);
				rate = \control;
				this.updateColors;
		}
	}
	
	updateColors {
		n.waveColors = if(rate === \audio, { 
			[rgb(255, 218, 000), rgb(255, 218, 000).alpha_(0.5)] 
		}, { 
			[rgb(125, 255, 205), rgb(125, 255, 205).alpha_(0.5)] 
		}).rotate(index.asInteger % 2);
	}
	
	switchRate { if(rate === \control) { this.rate = \audio } {  this.rate = \control } }
	
	
	setIndexToFirstHardwareBus {
		this.index = server.options.numInputBusChannels;
		this.rate = \audio;
	}

}
